--[[
	Support functions for the Gardener system
--]]

function GetZoneID()
	return sendMacro("GetZoneID()");
end;

function BuyMaterials()
	sendMacro("PlantCare:BuyMaterials();");
end;

-- Get planting level
function PlantingLevel()
	local currValue, extraValue, maxValue = sendMacro("GetPlayerSkilled(\"PLANT\");");
	return currValue;
end;

function getNumPots()
	if(not player.free_field1) then
		error("You can't run this directly\n",0);
	end
	
	local npots = player.free_field1;
	if not (npots > 0) then
		error("Somethings wrong, a planter cant have 0 pots\n",0);
	end;
	
	return npots;
end;

function setNumPots(n)
	player.free_field1 = n;
end;

-- Buy the nessesary consumables
function buySeeds(npc,npots,n)
	local nseeds = {};
	local level = PlantingLevel();
	
	nseeds[NTYPE_WOOD] = npots * wood_factor * batch_factor;
	nseeds[NTYPE_HERB] = npots * herb_factor * batch_factor;
	nseeds[NTYPE_ORE]  = npots * ore_factor  * batch_factor;
	
	-- Which seeds? (WOOD, HERB, ORB)
	local seed_names={};
	for id,s in pairs(SeedDB) do
		-- Do we have level for it?
		if (level >= s.Minlvl) then
			--
			-- Make more out of this logic, fix level to make
			-- make best level
			--
			seed_names[s.Type] = s.Id;
		end;
	end;
	
	-- Open NPC
	player:openStore(seed_npc);
	for type,id in pairs(seed_names) do
		printf("Purchasing %d of \"%s\"\n", nseeds[type], SeedDB[id].Name);
		inventory:storeBuyItem(id, nseeds[type]);
	end;
	yrest(500);
	RoMScript("CloseWindows()");
end;

--
-- Make sure we have the specifiec number of batches in backpack
--
function buyMaterials(npc, batches, n)	
	local level = PlantingLevel();

	-- count water, assume same amount fertilizer
	local count = 0;
	for i,v in pairs(PlantingMaterialsDB) do
		if ((v.Type == "WATER") and (v.Minlvl <= level)) then
			count = count + inventory:itemTotalCount(v.Name);
		end
	end
	
	-- Trust plantcare to do the right thing here
	-- but would like to calculate needed and buy
	if (count<250) then
		player:openStore(npc,n);
		BuyMaterials();
		yrest(500);
		RoMScript("CloseWindows()");
	end;
end;

--
-- Figure out the number of pots we have
--
function countPots()
	local n=0;
	local _pot = normaliseString(" pot")
	local objectList = CObjectList();
	
	objectList:update();
	local objSize = objectList:size()
	
	for i = 0,objSize do 
		obj = objectList:getObject(i);
		_name = normaliseString(obj.Name)
		if string.find(_name,_pot) ~= nil and obj.Type == 0 then
			n = n + 1;
		end
	end
	return n;
end;

-- Figure out number of seeds we have
function countSeeds()
	local n=0;

	inventory:update();
	for id,v in pairs(SeedDB) do
		n = n + inventory:itemTotalCount(id);
	end
	return n;
end;